HTTP::Headers -

# struct HTTP::Headers

- HTTP::Headers
- Struct
- Value
- Object

## Overview

A `Hash`-like object that holds HTTP headers.

Two headers are considered the same if their downcase representation is the same (in which `_` is the downcase version of `-`).

## Included Modules

- Enumerable({String, Array(String)})

## Defined in:

## Constructors

- .new

## Instance Method Summary

- #==(other : Hash)
- #==(other : self)
- #[](key)
- #[]=(key, value : String)
- #[]=(key, value : Array(String))
- #[]?(key)
- #add(key, value : String)
- #add(key, value : Array(String))
- #add?(key, value : String)
- #add?(key, value : Array(String))
- #clone
- #delete(key)
- #dup
- #each(&block)
- #empty?
- #fetch(key, &block)
- #fetch(key, default)
- #get(key)
- #get?(key)
- #has_key?(key)
- #includes_word?(key, word)

  Returns if among the headers for key there is some that contains word as a value.

- #inspect(io : IO) : Nil
- #merge!(other)
- #pretty_print(pp)
- #same?(other : HTTP::Headers)
- #to_s(io : IO) : Nil
- #valid_value?(value)

## Macro Summary

- method_missing(call)

### Instance methods inherited from module `Enumerable({String, Array(String)})`

all?(&block)
all?(pattern)
all? all?, any?(&block)
any?(pattern)
any? any?, chunks(&block : {String, Array(String)} -> U) forall U chunks, compact_map(&block) compact_map, count(item)
count(&block) count, cycle(&block)
cycle(n, &block) cycle, each(&block : {String, Array(String)} -> UNDERSCORE) each, each_cons(count : Int, reuse = false, &block) each_cons, each_slice(count : Int, reuse = false, &block) each_slice, each_with_index(offset = 0, &block) each_with_index, each_with_object(obj, &block) each_with_object, find(if_none = nil, &block) find, first(count : Int)
first first, first? first?, flat_map(&block : {String, Array(String)} -> Array(U) | Iterator(U) | U) forall U flat_map, grep(pattern) grep, group_by(&block : {String, Array(String)} -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &block) forall U in_groups_of, includes?(obj) includes?, index(&block)
index(obj) index, index_by(&block : {String, Array(String)} -> U) forall U index_by, join(separator = "", &block)
join(separator, io, &block)
join(separator, io)
join(separator = "") join, map(&block : {String, Array(String)} -> U) forall U map, map_with_index(&block : {String, Array(String)}, Int32 -> U) forall U map_with_index, max max, max? max?, max_by(&block : {String, Array(String)} -> U) forall U max_by, max_by?(&block : {String, Array(String)} -> U) forall U max_by?, max_of(&block : {String, Array(String)} -> U) forall U max_of, max_of?(&block : {String, Array(String)} -> U) forall U max_of?, min min, min? min?, min_by(&block : {String, Array(String)} -> U) forall U min_by, min_by?(&block : {String, Array(String)} -> U) forall U min_by?, min_of(&block : {String, Array(String)} -> U) forall U min_of, min_of?(&block : {String, Array(String)} -> U) forall U min_of?, minmax minmax, minmax? minmax?, minmax_by(&block : {String, Array(String)} -> U) forall U minmax_by, minmax_by?(&block : {String, Array(String)} -> U) forall U minmax_by?, minmax_of(&block : {String, Array(String)} -> U) forall U minmax_of, minmax_of?(&block : {String, Array(String)} -> U) forall U minmax_of?, none?
none?(pattern)
none?(&block) none?, one?(&block)
one?(pattern)
one? one?, partition(&block) partition, product(&block)
product(initial : Number, &block)
product
product(initial : Number) product, reduce(memo, &block)
reduce(&block) reduce, reduce?(&block) reduce?, reject(&block : {String, Array(String)} -> )
reject(type : U.class) forall U
reject(pattern) reject, select(pattern)
select(type : U.class) forall U
select(&block : {String, Array(String)} -> ) select, size size, skip(count : Int) skip, skip_while(&block) skip_while, sum(initial)
sum
sum(initial, &block)
sum(&block) sum, take_while(&block) take_while, tally : Hash({String, Array(String)}, Int32) tally, to_a to_a, to_h
to_h(&block : {String, Array(String)} -> Tuple(K, V)) forall K, V to_h, to_set to_set, zip(*others : Indexable | Iterable | Iterator, &block)
zip(*others : Indexable | Iterable | Iterator) zip, zip?(*others : Indexable | Iterable | Iterator, &block)
zip?(*others : Indexable | Iterable | Iterator) zip?

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new #

## Instance Method Detail

def ==(other : Hash) #
def ==(other : self) #
def [](key) #
def []=(key, value : String) #
def []=(key, value : Array(String)) #
def []?(key) #
def add(key, value : String) #
def add(key, value : Array(String)) #
def add?(key, value : String) #
def add?(key, value : Array(String)) #
def clone #
def delete(key) #
def dup #
def each(&block) #
def empty? #
def fetch(key, &block) #
def fetch(key, default) #
def get(key) #
def get?(key) #
def has_key?(key) #
def includes_word?(key, word) #

Returns if among the headers for key there is some that contains word as a value. The word is expected to match between word boundaries (i.e. non-alphanumeric chars).

    require "http/headers"

    headers = HTTP::Headers{"Connection" => "keep-alive, Upgrade"}
    headers.includes_word?("Connection", "Upgrade") # => true

def inspect(io : IO) : Nil #
def merge!(other) #
def pretty_print(pp) #
def same?(other : HTTP::Headers) #
def to_s(io : IO) : Nil #
def valid_value?(value) #

## Macro Detail

macro method_missing(call) #